package cn.ibizlab.r7.runtime.service.runtimemgr.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.core.r7rt_base.valuerule.anno.userobject.*;
import cn.ibizlab.r7.runtime.core.r7rt_base.domain.UserObject;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[UserObjectDTO]
 */
public class UserObjectDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @UserObjectCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [USEROBJECTTYPE]
     *
     */
    @UserObjectUserObjectTypeDefault(info = "默认规则")
    private String userObjectType;

    @JsonIgnore
    private boolean userObjectTypeDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @UserObjectUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [ENABLE]
     *
     */
    @UserObjectEnableDefault(info = "默认规则")
    private Integer enable;

    @JsonIgnore
    private boolean enableDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @UserObjectCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [USEROBJECTID]
     *
     */
    @UserObjectUserObjectIdDefault(info = "默认规则")
    private String userObjectId;

    @JsonIgnore
    private boolean userObjectIdDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @UserObjectUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [USEROBJECTNAME]
     *
     */
    @UserObjectUserObjectNameDefault(info = "默认规则")
    private String userObjectName;

    @JsonIgnore
    private boolean userObjectNameDirtyFlag;

    /**
     * 属性 [MEMO]
     *
     */
    @UserObjectMemoDefault(info = "默认规则")
    private String memo;

    @JsonIgnore
    private boolean memoDirtyFlag;


    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [USEROBJECTTYPE]
     */
    @JsonProperty("userobjecttype")
    public String getUserObjectType(){
        return userObjectType ;
    }

    /**
     * 设置 [USEROBJECTTYPE]
     */
    @JsonProperty("userobjecttype")
    public void setUserObjectType(String  userObjectType){
        this.userObjectType = userObjectType ;
        this.userObjectTypeDirtyFlag = true ;
    }

    /**
     * 获取 [USEROBJECTTYPE]脏标记
     */
    @JsonIgnore
    public boolean getUserObjectTypeDirtyFlag(){
        return userObjectTypeDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [ENABLE]
     */
    @JsonProperty("enable")
    public Integer getEnable(){
        return enable ;
    }

    /**
     * 设置 [ENABLE]
     */
    @JsonProperty("enable")
    public void setEnable(Integer  enable){
        this.enable = enable ;
        this.enableDirtyFlag = true ;
    }

    /**
     * 获取 [ENABLE]脏标记
     */
    @JsonIgnore
    public boolean getEnableDirtyFlag(){
        return enableDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [USEROBJECTID]
     */
    @JsonProperty("userobjectid")
    public String getUserObjectId(){
        return userObjectId ;
    }

    /**
     * 设置 [USEROBJECTID]
     */
    @JsonProperty("userobjectid")
    public void setUserObjectId(String  userObjectId){
        this.userObjectId = userObjectId ;
        this.userObjectIdDirtyFlag = true ;
    }

    /**
     * 获取 [USEROBJECTID]脏标记
     */
    @JsonIgnore
    public boolean getUserObjectIdDirtyFlag(){
        return userObjectIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [USEROBJECTNAME]
     */
    @JsonProperty("userobjectname")
    public String getUserObjectName(){
        return userObjectName ;
    }

    /**
     * 设置 [USEROBJECTNAME]
     */
    @JsonProperty("userobjectname")
    public void setUserObjectName(String  userObjectName){
        this.userObjectName = userObjectName ;
        this.userObjectNameDirtyFlag = true ;
    }

    /**
     * 获取 [USEROBJECTNAME]脏标记
     */
    @JsonIgnore
    public boolean getUserObjectNameDirtyFlag(){
        return userObjectNameDirtyFlag ;
    }

    /**
     * 获取 [MEMO]
     */
    @JsonProperty("memo")
    public String getMemo(){
        return memo ;
    }

    /**
     * 设置 [MEMO]
     */
    @JsonProperty("memo")
    public void setMemo(String  memo){
        this.memo = memo ;
        this.memoDirtyFlag = true ;
    }

    /**
     * 获取 [MEMO]脏标记
     */
    @JsonIgnore
    public boolean getMemoDirtyFlag(){
        return memoDirtyFlag ;
    }



    public UserObject toDO() {
        UserObject srfdomain = new UserObject();
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getUserObjectTypeDirtyFlag())
            srfdomain.setUserObjectType(userObjectType);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getEnableDirtyFlag())
            srfdomain.setEnable(enable);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getUserObjectIdDirtyFlag())
            srfdomain.setUserObjectId(userObjectId);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getUserObjectNameDirtyFlag())
            srfdomain.setUserObjectName(userObjectName);
        if(getMemoDirtyFlag())
            srfdomain.setMemo(memo);

        return srfdomain;
    }

    public void fromDO(UserObject srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getUserObjectTypeDirtyFlag())
            this.setUserObjectType(srfdomain.getUserObjectType());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getEnableDirtyFlag())
            this.setEnable(srfdomain.getEnable());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getUserObjectIdDirtyFlag())
            this.setUserObjectId(srfdomain.getUserObjectId());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getUserObjectNameDirtyFlag())
            this.setUserObjectName(srfdomain.getUserObjectName());
        if(srfdomain.getMemoDirtyFlag())
            this.setMemo(srfdomain.getMemo());

    }

    public List<UserObjectDTO> fromDOPage(List<UserObject> poPage)   {
        if(poPage == null)
            return null;
        List<UserObjectDTO> dtos=new ArrayList<UserObjectDTO>();
        for(UserObject domain : poPage) {
            UserObjectDTO dto = new UserObjectDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

